import sys
import lwsdk
import random
import math
import lwsdk


__author__     = " Peter Balazs"
__date__       = "June 20 2014"
__copyright__  = "Copyright (C) 2014 Peter Balazs"
__version__    = "1.0"
__maintainer__ = "Peter Balazs"
__email__      = "info@visionsupreme.net"
__status__     = "beta"
__lwver__      = "2015"

class randomFlare(lwsdk.IGeneric):
    def __init__(self, context):
        super(randomFlare, self).__init__()

    def process(self, ga):
        lwsdk.command('SelectAllLights')
        items = lwsdk.LWInterfaceInfo().selected_items()
        ui = lwsdk.LWPanels()
        panel = ui.create('Flare Randomizer')

        msg = lwsdk.LWMessageFuncs()
        c1 = panel.dist_ctl('Minimum flare intensity:')
        c2 = panel.dist_ctl('Maximum flare intensity:')
        
        panel.align_controls_vertical([c1])
        panel.size_to_layout(5, 5)

        if panel.open(lwsdk.PANF_BLOCKING | lwsdk.PANF_CANCEL) == 0:
            ui.destroy(panel)
            return lwsdk.AFUNC_OK
            
        for item in items:
            id   = lwsdk.itemid_to_str( item )
            #from lwsdk.pris.layout.cs import selectitem
            #selectitem(id)
            #Select light 
            cmd = "SelectItem " + str(id)
            lwsdk.command(cmd)
            #RemoveEnvelope FlareIntensity
            cmd = "RemoveEnvelope FlareIntensity"
            lwsdk.command(cmd)
            
            #lwsdk.command( "FlareCentralRing" )
            #lwsdk.command( "FlareRedOuterGlow" )            
            
            #Randomize flare intensities
            randintensity = random.uniform(c1.get_float(),c2.get_float())
            if random.randint(0,1000) > 900:
                randintensity = 0.045
            
            cmd = "SetFlareIntensity " + str(randintensity)
            lwsdk.command(cmd)
            #random streaksstarfilte
            
            #cmd = "FlareFadeBehindObjects "
            #lwsdk.command(cmd)
            
            cmd = "FlareStreaksStarFilter " + str( random.randint(0,10))
            lwsdk.command( cmd )
            #lwsdk.command( "FlareCentralRing" )
            #lwsdk.command( "FlareRedOuterGlow" )
            # SETS RANDOM LIGHT COLORS
            randR = random.uniform(0.1, 1.0)
            randG = random.uniform(0.9, 1.0)
            randB = random.uniform(0.7, 1.0)
            cmd = "LightColor " + str(randR) + " " + str(randG) + " " + str(randB)
            lwsdk.command( cmd ) #END RANDOM LIGHT COLOR SETUP
            randAngle = random.uniform(0 , 85 )
            cmd = "FlareStreaksRotation " + str(randAngle)
            lwsdk.command( cmd )
            #cmd = "FlareFadeWithDistance " + str(randAngle)
            #lwsdk.command( cmd )
        return lwsdk.AFUNC_OK



def setkey(self, channel, value):
        env_func = lwsdk.LWEnvelopeFuncs()
        item_info = lwsdk.LWItemInfo()
        group = item_info.chanGroup( self._item_ID )
        env = self.findEnv( group, channel )
        key = env_func.findKey( env, lwsdk.LWTimeInfo().time )
        if not key:
            key = env_func.createKey( env, lwsdk.LWTimeInfo().time, value )
        env_func.keySet( env, key, lwsdk.LWKEY_VALUE, value )


ServerTagInfo = [
                    ( "Python randomFlare", lwsdk.SRVTAG_USERNAME | lwsdk.LANGID_USENGLISH ),
                    ( "randomFlare", lwsdk.SRVTAG_BUTTONNAME | lwsdk.LANGID_USENGLISH ),
                    ( "Utilities/Python", lwsdk.SRVTAG_MENU | lwsdk.LANGID_USENGLISH )
                ]

ServerRecord = { lwsdk.GenericFactory("LW_randomFlare", randomFlare) : ServerTagInfo }

